use crc::{Crc, CRC_16_IBM_3740};

use crate::ldpc::ldpc_encode;

pub struct RawPacket(pub [u8; 256]);

pub struct FecPacket(pub [u8; 256 + 2 + 65]);

impl From<RawPacket> for FecPacket {
    fn from(value: RawPacket) -> Self {
        let crc = Crc::<u16>::new(&CRC_16_IBM_3740);

        let checksum = crc.checksum(&value.0);

        let mut data = [0; 256 + 2 + 65];
        data[0..256].copy_from_slice(&value.0);
        data[256..258].copy_from_slice(&checksum.to_le_bytes());

        ldpc_encode(&mut data);

        FecPacket(data)
    }
}
